#include "HelloWorldControl.h"

#define WNDCLASSNAME "HelloWorldControl"

//------------------------------------------------------------------------
// todo: these two need to move in their respective templates
//------------------------------------------------------------------------
#ifdef XPP_ACTIVEX // OleControl
HRESULT HelloWorldControl::OnActivateInPlace(BOOL bUIActivate, LPMSG pMsg) {
  LRESULT r = HELLOWORLD_CONTROL_ANCESTOR::OnActivateInPlace(bUIActivate, pMsg);
  createWindow();
  return r;
}
#endif

#ifdef XPP_MOZILLA // Mozilla
void HelloWorldControl::SetHwnd(HWND wnd) {
  HELLOWORLD_CONTROL_ANCESTOR::SetHwnd(wnd);
  createWindow();
}
#endif

//------------------------------------------------------------------------
// todo: make portable window handlers in std/window.xph and make each
// template use that
//------------------------------------------------------------------------
LRESULT CALLBACK HelloWorldControl_wndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  HelloWorldControl *lThis = (HelloWorldControl *)GetWindowLong(hwnd, GWL_USERDATA);
  if (!lThis)
    return DefWindowProc(hwnd, uMsg, wParam, lParam);
  else
    return lThis->wndProc(hwnd, uMsg, wParam, lParam);
}

void HelloWorldControl::createWindow() {
  RECT r;
  ::GetClientRect((HWND)HELLOWORLD_CONTROL_ANCESTOR::GetHwnd(), &r);
  WNDCLASS wc;
  HINSTANCE instance = GetModuleHandle(NULL);
  memset(&wc, 0, sizeof(wc));
  wc.lpfnWndProc = HelloWorldControl_wndProc;
  wc.hInstance = instance;
  wc.lpszClassName = WNDCLASSNAME;
  wc.style = 0;
  RegisterClass(&wc);
  HWND parent = NULL;
  #if defined(XPP_MOZILLA)
  parent = HELLOWORLD_CONTROL_ANCESTOR::GetHwnd();
  #elif defined(XPP_ACTIVEX)
  parent = HELLOWORLD_CONTROL_ANCESTOR::m_hWnd;
  #endif

  hWnd = CreateWindowEx(0, 
                        WNDCLASSNAME,
                        "",
                        WS_CHILD,
                        0,0,
                        r.right-r.left,r.bottom-r.top,
                        parent,
                        NULL,
                        instance,
                        NULL);

  if (hWnd) {
    ::SetWindowLong(hWnd, GWL_USERDATA, (long)this);
    ::ShowWindow(hWnd, SW_NORMAL);
  }
}

LRESULT HelloWorldControl::wndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
  switch (uMsg) {
    case WM_PAINT: {
      PAINTSTRUCT ps;
      HDC dc = ::BeginPaint(hwnd, &ps);
      RECT r;
      ::GetClientRect(hwnd, &r);
      ::FillRect(dc, &r, (HBRUSH)GetStockObject(WHITE_BRUSH));
      ::TextOut(dc, 0, 0, WNDCLASSNAME, strlen(WNDCLASSNAME));
      ::EndPaint(hwnd, &ps);
      return 0;
    }
    case WM_TIMER: {
      ::KillTimer(hwnd, 0);
      AfterHelloEvent();
    }
  }

  return ::DefWindowProc(hwnd, uMsg, wParam, lParam);
}

//------------------------------------------------------------------------
//------------------------------------------------------------------------
HelloWorldControl::HelloWorldControl() : hWnd(NULL) {
}

HelloWorldControl::~HelloWorldControl() {
  // todo: call this from the templated ancestor
  if (IsWindow(hWnd))
    ::DestroyWindow(hWnd);
  UnregisterClass(WNDCLASSNAME, GetModuleHandle(NULL));
}

void HelloWorldControl::MsgBox(int a) {
  char title[64];
  sprintf(title, "a = %d", a);
  ::MessageBox((HWND)GetHwnd(), "Hello, world", title, MB_OK);
  ::SetTimer((HWND)GetHwnd(), 0, 1000, NULL);
}


void HelloWorldControl::AfterHelloEvent() {
 event_AfterHelloEvent();
}

